# Services, Managers and Drivers

The responsibilities of Services, Managers, and Drivers, can be a bit confusing to people that are new to manila. This document attempts to outline the division of responsibilities to make understanding the system a little bit easier.

Currently, Managers and Drivers are specified by flags and loaded using utils.load_object(). This method allows for them to be implemented as singletons, classes, modules or objects. As long as the path specified by the flag leads to an object (or a callable that returns an object) that responds to getattr, it should work as a manager or driver.

## The `manila.service` Module

Generic Node base class for all workers that run on hosts.

class Service(host, binary, topic, manager, report_interval=None, periodic_interval=None, periodic_fuzzy_delay=None, service_name=None, coordination=False, *args, **kwargs)

  Bases: `Service`

  Service object for binaries running on hosts.

  A service takes a manager and enables rpc by listening to queues based on topic. It also periodically runs tasks on the manager and reports it state to the database services table.

  cleanup_services()

    Remove the stopped services of same topic from the datastore.

  classmethod create(host=None, binary=None, topic=None, manager=None, report_interval=None, periodic_interval=None, periodic_fuzzy_delay=None, service_name=None, coordination=False)

    Instantiates class and passes back application object.

    Parameters:

      - host – defaults to CONF.host

      - binary – defaults to basename of executable

      - topic – defaults to bin_name - ‘manila-’ part

      - manager – defaults to CONF.<topic>_manager

      - report_interval – defaults to CONF.report_interval

      - periodic_interval – defaults to CONF.periodic_interval

      - periodic_fuzzy_delay – defaults to CONF.periodic_fuzzy_delay

  kill()

    Destroy the service object in the datastore.

  periodic_tasks(raise_on_error=False)

    Tasks to be run at a periodic interval.

  report_state()

    Update the state of this service in the datastore.

  start()

    Start a service.

  stop()

    Stop a service.

    Parameters:

      graceful – indicates whether to wait for all threads to finish or terminate them instantly

  wait()

    Wait for a service to shut down.

class WSGIService(name, loader=None)

  Bases: `ServiceBase`

  Provides ability to launch API from a ‘paste’ configuration.

  reset()

    Reset server greenpool size to default.

    Returns:

      None

  start()

    Start serving this service using loaded configuration.

    Also, retrieve updated port number in case ‘0’ was passed in, which indicates a random port should be used.

    Returns:

      None

  stop()

    Stop serving this API.

    Returns:

      None

  wait()

    Wait for the service to stop serving this API.

    Returns:

      None

process_launcher()

serve(server, workers=None)

setup_profiler(binary, host)

wait()

## The `manila.manager` Module

Base Manager class.

Managers are responsible for a certain aspect of the system. It is a logical grouping of code relating to a portion of the system. In general other components should be using the manager to make changes to the components that it is responsible for.

For example, other components that need to deal with volumes in some way, should do so by calling methods on the VolumeManager instead of directly changing fields in the database. This allows us to keep all of the code relating to volumes in the same place.

We have adopted a basic strategy of Smart managers and dumb data, which means rather than attaching methods to data objects, components should call manager methods that act on the data.

Methods on managers that can be executed locally should be called directly. If a particular method must execute on a remote host, this should be done via rpc to the service that wraps the manager

Managers should be responsible for most of the db access, and non-implementation specific data. Anything implementation specific that can’t be generalized should be done by the Driver.

In general, we prefer to have one manager with multiple drivers for different implementations, but sometimes it makes sense to have multiple managers. You can think of it this way: Abstract different overall strategies at the manager level(FlatNetwork vs VlanNetwork), and different implementations at the driver level(LinuxNetDriver vs CiscoNetDriver).

Managers will often provide methods for initial setup of a host or periodic tasks to a wrapping service.

This module provides Manager, a base class for managers.

class Manager(host=None, db_driver=None)

  Bases: `Base`, `PeriodicTasks`

  property RPC_API_VERSION

    Redefine this in child classes.

  init_host(service_id=None)

    Handle initialization if this is a standalone service.

    A hook point for services to execute tasks before the services are made available (i.e. showing up on RPC and starting to accept RPC calls) to other components. Child classes should override this method.

    Parameters:

      service_id – ID of the service where the manager is running.

  init_host_with_rpc(service_id=None)

    A hook for service to do jobs after RPC is ready.

    Like init_host(), this method is a hook where services get a chance to execute tasks that need RPC. Child classes should override this method.

    Parameters:

      service_id – ID of the service where the manager is running.

  is_service_ready()

    Method indicating if service is ready.

    This method should be overridden by subclasses which will return False when the back end is not ready yet.

  periodic_tasks(context, raise_on_error=False)

    Tasks to be run at a periodic interval.

  service_config(context)
  service_version(context)
  property target

    This property is used by oslo_messaging.

    https://wiki.openstack.org/wiki/Oslo/Messaging#API_Version_Negotiation

class PeriodicTasks

  Bases: `PeriodicTasks`

class SchedulerDependentManager(host=None, db_driver=None, service_name='undefined')

  Bases: `Manager`

  Periodically send capability updates to the Scheduler services.

  Services that need to update the Scheduler of their capabilities should derive from this class. Otherwise they can derive from manager.Manager directly. Updates are only sent after update_service_capabilities is called with non-None values.

  update_service_capabilities(capabilities)

    Remember these capabilities to send on next periodic update.

## Implementation-Specific Drivers

A manager will generally load a driver for some of its tasks. The driver is responsible for specific implementation details. Anything running shell commands on a host, or dealing with other non-python code should probably be happening in a driver.

Drivers should minimize touching the database, although it is currently acceptable for implementation specific data. This may be reconsidered at some point.

It usually makes sense to define an Abstract Base Class for the specific driver (i.e. VolumeDriver), to define the methods that a different driver would need to implement.

this page last updated: 2026-03-20 00:30:00

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug